/**
 *  TP 4 : Allocateur de ressources 
 * ------------------------------------
 * ce programme est tir de "Synchronisation  l'aide des smaphores et des moniteurs"
 *	Samia Bouzefrane/http://cedric.cnam.fr/~bouzefra
**/

#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <string.h>
#include <semaphore.h>
#define NbTh 5 /*Nombre de demandeurs de ressources */
#define M 100 //nombre de ressources total

pthread_t tid[NbTh];
pthread_mutex_t mutex=PTHREAD_MUTEX_INITIALIZER;
sem_t attente;

// variable critique
int NbRDispo = M; // nombre de ressources disponibles


void request(int m,int n);// demande de ressources
void release(int m,int n);// libration  de ressources

void *Demandeur(void *arg);

int main() {
	int i;
	
//initialisation du smaphores
	i= sem_init (&attente, 0,0);
	if(i!=0) printf("Problme de cration de smaphores \n");
	
//creation des threads demandeurs de ressources
	for(i=0;i<NbTh;i ++)
		pthread_create(&tid[i], NULL, Demandeur, (void*)i );

//attend la fin de toutes les threads
		
//destruction du mutex

	return 0;
}

void *Demandeur(void *arg) {
	int i = (int)arg;
	int j;
	srand(pthread_self());
	j=rand()%100;
	
	
/* demande de ressources */
	request(i,j);

/* temps d'utilisation */
	printf("Le thread %d utilise les ressources\n", i);
	usleep(rand()%200000);
	 
/* libration de ressources */
	release(i,j);

	pthread_exit(NULL);
}

void request(int m,int n) {
	
		if (n>NbRDispo) {
			
		}
		else {
			printf("Le thread %d alloue %d ressources\n",m,n);
			
			printf("Le nombre de ressources disponibles est %d \n", NbRDispo);
			
		}

	return;
}

void release(int m,int n) {

	
	printf("Le thread %d libere %d ressources\n",m, n);
	
	printf("Le nombre de ressources disponibles %d \n", NbRDispo);
	
	return;	
}
